#################################### 
#        hTP_SimpleDM v1.2         #
#                                  #
#     many thanks to:              # 
#            GODJonez              #
#            TP_Pred               #
#            british_assassin      # 
#            SuperDave             #
#            Errant                #
####################################

import es
import random
import popuplib
import gamethread
import playerlib
import datetime
import services
import langlib

from configobj import ConfigObj
from sqlite3 import dbapi2 as sqlite

info = es.AddonInfo()
info.name        = "hTP_SimpleDM"
info.version     = "beta1.2"
info.author      = "HitThePipe and TP_Predator"
info.url         = "http://forums.mattie.info/cs/forums/viewtopic.php?t=19484"
info.description = "CSS:DM In Python for ES"

class connection(object):
    def __init__(self,path):
        self.con = sqlite.connect(path)
        self.cur = self.con.cursor()
    def execute(self,sql):
        self.cur.execute(sql)
        self.con.commit()
    def query(self,sql):
        self.cur.execute(sql)
        return self.cur.fetchall()
    def close(self):
        self.con.close()
    def utfcode(self,value):
        if type(value).__name__ == 'unicode':
            return value.encode('utf-8')
        return value 
    def convertQuery(self,result):
        newresult = list()
        for row in result:
            newrow = [utfcode(item) for item in row]
            newresult.append(newrow)
        return newresult

dm_config = ConfigObj(es.getAddonPath('htp_dm') + '/dm_config.ini')
dm_lang = langlib.Strings(es.getAddonPath('htp_dm') + '/dm_lang.ini')
dbdm = connection(es.getAddonPath('htp_dm') + '/usersettings.db')

if int(dm_config['settings']['use_ranking']):
    es.load('htp_dm/ranking')
if int(dm_config['settings']['use_ba_bank']):
    usebank = int(dm_config['settings']['use_ba_bank'])
    es.load('htp_dm/bank')

rw = 0
cplayers = {}
auth = services.use('auth')
prefix = ('#green' + dm_config['settings']['message_prefix'] + '#default')


def load():
    global DDKills
    global DMMain
    global DMMenuP
    global DMMenuR1
    global ranks

    es.set('hTP_SimpleDM','v.beta1.2')
    es.makepublic('hTP_SimpleDM')
	
    if not es.exists('saycommand', 'guns'):
        es.regsaycmd('guns', 'htp_dm/send_main', 'Send Main Menu')
    if not es.exists('saycommand', 'ammo'):
        es.regsaycmd('ammo', 'htp_dm/stock_ammo', 'Restock Ammo')
    if not es.exists('saycommand', 'stats'):
        es.regsaycmd('stats', 'htp_dm/kills', 'Show player kills')

    dbdm.execute("CREATE TABLE IF NOT EXISTS [UserSettings] ([SteamID]VARCHAR(30) UNIQUE NOT NULL,[Name]VARCHAR(30),[Rifle]VARCHAR(30),[Pistol]VARCHAR(30),[SendMenu]INT,[Kills]INT,[Deaths]INT,[KD]VARCHAR(10),[LastConnect]VARCHAR(30))")

    DMMain = popuplib.create('dmm_popup')
    DMMain.addline(dm_lang('main menu'))
    DMMain.addline('-----------------------')
    DMMain.addline(popuplib.langstring('->1. ', dm_lang['new weapons']))
    DMMain.addline(popuplib.langstring('->2. ', dm_lang['previous weapons']))
    DMMain.addline(popuplib.langstring('->3. ', dm_lang['use same']))
    DMMain.addline(popuplib.langstring('->4. ', dm_lang['restock']))
    DMMain.menuselect = main_menuselect
    
    DDKills = popuplib.create('dmkills_popup')
    DDKills.addline('Stats')
    DDKills.addline('----------------')
    DDKills.addline('Kills :')
    DDKills.addline('Deaths :')
    DDKills.addline('K/D Ratio :')
    DDKills.addline('-----------------')
    DDKills.addline('->0. Exit')
    
    DMMenuP = popuplib.easymenu('dmp_popup', None, menup_menuselect)
    DMMenuP.settitle('Select Pistol')
    DMMenuP.addoption('weapon_glock', "Glock")
    DMMenuP.addoption('weapon_usp', "USP")
    DMMenuP.addoption('weapon_deagle', "Deagle")
    DMMenuP.addoption('weapon_p228', "P228")
    DMMenuP.addoption('weapon_fiveseven', "FiveSeven")
    DMMenuP.addoption('weapon_elite', "Elites")

    DMMenuR1 = popuplib.easymenu('dmr1_popup',None, menur1_menuselect)
    DMMenuR1.settitle('Select Primary')
    DMMenuR1.addoption('weapon_m4a1', "M4A1")
    DMMenuR1.addoption('weapon_ak47', "AK47")
    DMMenuR1.addoption('weapon_awp', "AWP")
    DMMenuR1.addoption('weapon_famas', "Famas")
    DMMenuR1.addoption('weapon_galil', "Galil")
    DMMenuR1.addoption('weapon_sg552', "Sg552")
    DMMenuR1.addoption('weapon_aug', "AUG")
    DMMenuR1.addoption('weapon_scout', "Scout")
    DMMenuR1.addoption('weapon_sg550', "Sg550")
    DMMenuR1.addoption('weapon_g3sg1', "G3Sg1")
    DMMenuR1.addoption('weapon_m3', "M3")
    DMMenuR1.addoption('weapon_xm1014', "Xm1014")
    DMMenuR1.addoption('weapon_m249', "M249")
    DMMenuR1.addoption('weapon_tmp', "TMP")
    DMMenuR1.addoption('weapon_mac10', "Mac10")
    DMMenuR1.addoption('weapon_mp5navy', "MP5")
    DMMenuR1.addoption('weapon_ump45', "UMP")
    DMMenuR1.addoption('weapon_p90', "P90")
    
    for player in es.getUseridList():
        steamid = es.getplayersteamid(player)
        getPlayer(player, steamid)
        gamethread.delayed(2, es.server.queuecmd, 'est_spawn %s 1' % player)       

    es.msg('#multi',prefix + dm_lang('dm on'))
    
def main_menuselect(userid, choice, popupid):
    if choice == 1:
        if not popuplib.isqueued('dmp_popup', userid):
            DMMenuP.send(userid)
    elif choice == 2:
        muser = playerlib.getPlayer(userid)
        if muser.get('teamid') > 1:
            GiveWeapons(userid)
    elif choice == 3:
        GiveWeapons(userid)	
        cplayers[userid] = (cplayers[userid][0],cplayers[userid][1],'0')
        es.tell (userid, '#multi', prefix + dm_lang('auto send'))
    elif choice == 4:
        auser = playerlib.getPlayer(userid)
        auser.set('ammo', ['primary', '120'])
        auser.set('ammo', ['secondary', '120'])

def menup_menuselect(userid, choice, popupid):
    if not popuplib.isqueued('dmr1_popup', userid):
        DMMenuR1.send(userid)
    cplayers[userid] = (cplayers[userid][0],choice,cplayers[userid][2])
    dbdm.execute("UPDATE UserSettings SET Pistol='%s' WHERE SteamID='%s'" % (choice, es.getplayersteamid(userid)))
	
def menur1_menuselect(userid, choice, popupid):
    cplayers[userid] = (choice,cplayers[userid][1],cplayers[userid][2]) 
    muser = playerlib.getPlayer(userid)
    if muser.get('teamid') > 1:
        GiveWeapons(userid)	
    steamid = es.getplayersteamid(userid)
    dbdm.execute("UPDATE UserSettings SET Rifle='%s' WHERE SteamID='%s'" % (choice, steamid))

def stock_ammo():
    user = es.getcmduserid()
    auser = playerlib.getPlayer(user)
    auser.set('ammo', ['primary', '120'])
    auser.set('ammo', ['secondary', '120'])		
	
def GiveWeapons (userid):
    rifle = cplayers[userid][0]
    pistol = cplayers[userid][1]
    es.server.queuecmd('es_xgive %s player_weaponstrip' %userid)
    es.server.queuecmd('es_xfire %s player_weaponstrip strip' %userid)
    gamethread.delayed(1, equip_player, (userid,pistol,rifle))

def equip_player(userid,pistol,rifle):
    es.server.queuecmd('es_xgive %s weapon_knife' %userid)
    es.server.queuecmd('es_xgive %s weapon_hegrenade' %userid)
    es.server.queuecmd('es_xgive %s item_assaultsuit' %userid)
    es.server.queuecmd('es_xgive %s %s' %(userid,pistol))
    es.server.queuecmd('es_xgive %s %s' %(userid,rifle))

def kills():
    user = es.getcmduserid()
    usersteam = es.getplayersteamid(user)
    (kills,deaths) = dbdm.query("SELECT Kills,Deaths FROM UserSettings WHERE SteamID='%s'" % usersteam)[0]
    kd = (kills + .0) / deaths
    DDKills.modline(3, 'Kills : %s' % kills)
    DDKills.modline(4, 'Deaths : %s' % deaths)
    DDKills.modline(5, 'K/D Ratio : %.2f' % kd)
    DDKills.send(user)
	
def es_map_start(event_var):
    es.dbgmsg(0, '***** Map start')
    popuplib.close('dmm_popup', playerlib.getUseridList('#human'))
    popuplib.close('dmp_popup', playerlib.getUseridList('#human'))
    popuplib.close('dmr1_popup', playerlib.getUseridList('#human'))
    date = datetime.date.today() - datetime.timedelta(int(dm_config['settings']['clear_inactive_users']))
    dbdm.execute("DELETE FROM UserSettings WHERE LastConnect<'%s'" %date) 

def player_activate(event_var):
    if event_var['es_steamid'] not in ('STEAM_ID_PENDING','BOT'):
        es.tell (event_var['userid'], '#multi', '#green[DM Commands]#default \'guns\' \'ammo\' \'stats\' \'top #\' \'rank\' ')
        getPlayer(event_var['userid'], event_var['es_steamid'])    
    else:
        es.tell (event_var['userid'], '#multi', '%s Your STEAM_ID has not been validated yet.' %prefix)
        es.tell (event_var['userid'], '#multi', '%s Cannot load your settings.' %prefix)
        es.tell (event_var['userid'], '#multi', '%s You will be given random weapons until validation.' %prefix)
        getbotweapons(event_var['userid'])  

def getPlayer(userid,steamid):
    if not es.isbot(userid):
        settings = dbdm.query("SELECT Rifle,Pistol,SendMenu,Name FROM UserSettings WHERE SteamID='%s'" % steamid)
        name = es.getplayername(userid)
        userid = int(userid)        
        if not settings:
            dbdm.execute("INSERT INTO UserSettings ('SteamID', 'Name', 'Rifle', 'Pistol', 'SendMenu', 'Kills', 'Deaths', 'LastConnect') VALUES ('%s', '%s', 'weapon_m4a1', 'weapon_deagle', '1', 0, 0, '%s')" % (steamid, name, datetime.date.today()))
            cplayers[userid] = ('weapon_m4a1', 'weapon_deagle', '1')
        else:
            settings = settings[0] 
            cplayers[userid] = settings
            if name == cplayers[userid][3]:
                dbdm.execute("UPDATE UserSettings SET LastConnect='%s' WHERE SteamID='%s'" %(datetime.date.today(),steamid))
            else:
                dbdm.execute("UPDATE UserSettings SET Name='%s',LastConnect='%s' WHERE SteamID='%s'" %(name,datetime.date.today(),steamid))
            cplayers[userid] = (cplayers[userid][0],cplayers[userid][1],cplayers[userid][2])

def player_changename(event_var):
    dbdm.execute("UPDATE UserSettings SET Name='%s' WHERE SteamID='%s'" %(event_var['newname'],event_var['es_steamid']))

def player_disconnect(event_var):
    global cplayers
    userid = event_var['userid']
    userid = int(userid)
    steamid = event_var['es_steamid']
    if steamid != 'BOT':
        kills = dbdm.query("SELECT Kills FROM UserSettings WHERE SteamID='%s'" %steamid)[0]
        if kills[0]:
            dbdm.execute("UPDATE UserSettings SET Rifle='%s',Pistol='%s',SendMenu='%s' WHERE SteamID='%s'" %(cplayers[userid][0],cplayers[userid][1],cplayers[userid][2],steamid))
            del cplayers[userid]
        else:
            dbdm.execute("DELETE FROM UserSettings WHERE SteamID='%s'" %steamid)
            del cplayers[userid]

def player_death(event_var):
    global rw
    gamethread.delayed(2.5, es.server.cmd, 'est_spawn %s' % event_var['userid'])
    if event_var['es_userteam'] != event_var['es_attackerteam'] and event_var['es_attackerteam'] in ('2','3'):
        attackersteam = event_var['es_attackersteamid']
        steamid = event_var['es_steamid']
        userid = event_var['userid']
        if attackersteam != 'BOT':
            if steamid != 'BOT':
                dbdm.execute("UPDATE UserSettings SET Deaths=(SELECT sum(Deaths+1) FROM UserSettings WHERE SteamID='%s') WHERE SteamID='%s'" %(steamid,steamid))
                dbdm.execute("UPDATE UserSettings SET Kills=(SELECT sum(Kills+1) FROM UserSettings WHERE SteamID='%s') WHERE SteamID='%s'" %(attackersteam,attackersteam))
                kd_update(steamid)
                kd_update(attackersteam)
                if usebank:
                    deposit(userid,attackersteam,event_var['weapon'],event_var['headshot'])
                    withdraw(userid,steamid,event_var['weapon'])

            if dm_config['settings']['count_bot_kills_deaths'] == '1':
                dbdm.execute("UPDATE UserSettings SET Kills=(SELECT sum(Kills+1) FROM UserSettings WHERE SteamID='%s') WHERE SteamID='%s'" %(attackersteam,attackersteam))
                kd_update(attackersteam)
                if usebank:
                    deposit(userid,attackersteam,event_var['weapon'],event_var['headshot'])

        if dm_config['settings']['count_bot_kills_deaths'] == '1':
            if event_var['es_steamid'] != 'BOT':
                dbdm.execute("UPDATE UserSettings SET Deaths=(SELECT sum(Deaths+1) FROM UserSettings WHERE SteamID='%s') WHERE SteamID='%s'" %(steamid,steamid))
                if usebank:
                    kd_update(steamid)
                    withdraw(userid,steamid,event_var['weapon'])
    rw += 1
    if rw > 10:
        remove_weapons()
        rw = 0

def deposit(userid,steamid,weapon,headshot):
    es.event('initialize','htp_deposit')
    es.event('setint','htp_deposit','userid',userid)
    es.event('setstring','htp_deposit','steamid',steamid)
    es.event('setstring','htp_deposit','weapon',weapon)
    es.event('setint','htp_deposit','headshot',headshot)
    es.event('fire','htp_deposit')

def withdraw(userid,steamid,weapon):
    es.event('initialize','htp_withdraw')
    es.event('setint','htp_withdraw','userid',userid)
    es.event('setstring','htp_withdraw','steamid',steamid)
    es.event('setstring','htp_withdraw','weapon',weapon)
    es.event('fire','htp_withdraw')

def kd_update(steamid):
    if dbdm.query("SELECT Deaths FROM UserSettings WHERE SteamID='%s'" %steamid):
        dbdm.execute("UPDATE UserSettings SET KD=(SELECT sum((Kills + 0.) / Deaths) FROM UserSettings WHERE SteamID='%s') WHERE SteamID='%s'" %(steamid,steamid))
    else:
        dbdm.execute("UPDATE UserSettings SET KD=(SELECT sum((Kills + 0.)) FROM UserSettings WHERE SteamID='%s') WHERE SteamID='%s'" %(steamid,steamid))		

def player_team(event_var):
    if event_var['disconnect'] and int(event_var['team']) > 1:
        gamethread.delayed(1, es.server.cmd, 'est_spawn %s 1' % event_var['userid'])
	
def player_spawn(event_var):
    if int(event_var['es_userteam']) > 1:
        userid = int(event_var['userid'])
        steamid = event_var['es_steamid']
        current_player = playerlib.getPlayer(userid)
        current_player.set('health', 999)
        gamethread.delayed(3, current_player.set, ('health', 100))
        if steamid not in ('BOT', 'STEAM_ID_PENDING'):
            if cplayers[userid]:
                if cplayers[userid][2] == '1':
                    if not popuplib.isqueued('dmm_popup', userid):
                        popuplib.send('dmm_popup', userid)
                else:
                    GiveWeapons(userid)
            else:
                getplayer(userid,steamid)
        else:            
            getbotweapons(userid)

def round_start(event_var):
    es.remove('weapon_c4')
    gamethread.delayed(3,remove_weapons())
    userid = int(es.getuserid())
    if userid:
        es.server.queuecmd('es_xfire %d func_buyzone disable' % userid)

def send_main():
    userid = es.getcmduserid()
    DMMain.send(userid)
    cplayers[userid] = (cplayers[userid][0],cplayers[userid][1], '1')
    es.tell (userid, '#multi', '%s Menu Enabled' %prefix)	
	
def remove_weapons():
    es.server.queuecmd('est_DeleteRagDolls')
    es.server.queuecmd('est_RemoveIdle weapon')
    es.server.queuecmd('est_RemoveIdle item')

def getbotweapons(userid):
    pistol = random.choice(('weapon_glock', 'weapon_deagle', 'weapon_usp', 'weapon_elite', 'weapon_usp', 'weapon_p228', 'weapon_fiveseven'))
    rifle = random.choice(('weapon_m4a1', 'weapon_ak47', 'weapon_awp', 'weapon_mp5navy', 'weapon_p90', 'weapon_galil', 'weapon_scout', 'weapon_sg552', 'weapon_aug'))
    es.server.queuecmd('es_xgive %s player_weaponstrip' %userid)
    es.server.queuecmd('es_xfire %s player_weaponstrip strip' %userid)
    gamethread.delayed(1, equip_player, (userid,pistol,rifle))

def weapon_reload(event_var):
    auser = playerlib.getPlayer(event_var['userid'])
    auser.set('ammo', ['primary', '120'])
    auser.set('ammo', ['secondary', '30'])	
   
def unload():
    popuplib.delete('dmm_popup')
    popuplib.delete('dmkills_popup')
    popuplib.delete('dmp_popup')
    popuplib.delete('dmr1_popup')
    es.unregsaycmd('guns')
    es.unregsaycmd('ammo')
    es.unregsaycmd('stats')
    dbdm.close
    es.unload('htp_dm/ranking')
    es.unload('htp_dm/bank')
    es.msg('#multi', prefix + dm_lang('dm off'))     
